Name:       cswrap
Version:    1.0.4
Release:    1%{?dist}
Summary:    Generic compiler wrapper

Group:      Development/Tools
License:    GPLv3+
URL:        http://git.fedorahosted.org/cgit/%{name}.git
Source0:    http://git.fedorahosted.org/cgit/%{name}.git/snapshot/%{name}-%{version}.tar.xz

BuildRequires: asciidoc

# csmock copies the resulting cswrap binary into mock chroot, which may contain
# an older (e.g. RHEL-5) version of glibc, and it would not dynamically link
# against the old version of glibc if it was built against a newer one.
# Therefor we link glibc statically.
%if (0%{?fedora} >= 12 || 0%{?rhel} >= 6)
BuildRequires: glibc-static
%endif

%description
Generic compiler wrapper used by csmock to capture diagnostic messages.

%prep
%setup -q

%build
make %{?_smp_mflags} \
    CFLAGS="$RPM_OPT_FLAGS -DPATH_TO_WRAP='\"%{_libdir}/cswrap\"'" \
    LDFLAGS="$RPM_OPT_FLAGS -static -pthread"

%check
PATH="$RPM_BUILD_ROOT%{_libdir}/cswrap:$PATH"
export PATH
make clean
make %{?_smp_mflags} CFLAGS="-ansi -pedantic" 2>&1 | grep "$PWD" > /dev/null

%install
install -m0755 -d \
    "$RPM_BUILD_ROOT%{_bindir}"                \
    "$RPM_BUILD_ROOT%{_libdir}"                \
    "$RPM_BUILD_ROOT%{_libdir}/cswrap"         \
    "$RPM_BUILD_ROOT%{_mandir}/man1"

install -p -m0755 %{name} "$RPM_BUILD_ROOT%{_bindir}"
install -p -m0644 %{name}.1 "$RPM_BUILD_ROOT%{_mandir}/man1"

for i in c++ cc g++ gcc clang clang++ cppcheck \
    %{_arch}-redhat-linux-c++ \
    %{_arch}-redhat-linux-g++ \
    %{_arch}-redhat-linux-gcc
do
    ln -s ../../bin/cswrap "$RPM_BUILD_ROOT%{_libdir}/cswrap/$i"
done

%files
%{_bindir}/cswrap
%{_libdir}/cswrap
%{_mandir}/man1/%{name}.1*
%doc COPYING README

%changelog
* Thu Jul 17 2014 Kamil Dudka <kdudka@redhat.com> 1.0.4-1
- update to latest upstream

* Thu Mar 27 2014 Kamil Dudka <kdudka@redhat.com> 1.0.3-1
- update to latest upstream

* Mon Mar 10 2014 Kamil Dudka <kdudka@redhat.com> 1.0.2-2
- abandon RHEL-5 compatibility (#1066028)

* Wed Feb 19 2014 Kamil Dudka <kdudka@redhat.com> 1.0.2-1
- packaged for Fedora
